--------------------------------------------------------------------------------
-- Code developed by Generis Technology Limited
--
-- Product Name: B-Smart
--
-- Component Name: Meter Asset Manager
--
-- Description: Script to amend B-Smart data to allow for the presence of 
-- ENI and ELK value for ESP Networks and introduction of ENI Abbr value for
-- Enoi SPA
--
-- Amendment History:                   Date        Author            Vers
-- ------------------                   ---------   -------           -----
-- B-Smart Initial Release              09-JAN-20   Generis           1.0
--------------------------------------------------------------------------------
--
-- SET SERVEROUTPUT ON SIZE 1000000
SET VERIFY OFF
--
SET SCAN OFF
--
PROMPT
PROMPT Script to correct previous amendments to ESP Networks Ltd and Enoi SPA
PROMPT
PROMPT Version 1.0
PROMPT
--
DECLARE

  invalid_column      EXCEPTION;
  is_snapshot         EXCEPTION;
  row_exists          EXCEPTION;
  fk_violated         EXCEPTION;
  PRAGMA EXCEPTION_INIT(invalid_column, -904);
  PRAGMA EXCEPTION_INIT(is_snapshot, -1732);
  PRAGMA EXCEPTION_INIT(row_exists, -1);
  PRAGMA EXCEPTION_INIT(fk_violated, -2292);

BEGIN
					
	EXECUTE IMMEDIATE 'UPDATE MARKET_PARTICIPANT
                        SET MARKET_PARTICIPANT_ABBR_NAME = ''ELK'',
                            LAST_UPDATE_USER_ID = ''CCN10001654'',
                            LAST_UPDATE_DATE = SYSDATE
                      WHERE MARKET_PARTICIPANT_CODE = ''ENI''
                        AND MARKET_PARTICIPANT_ABBR_NAME = ''ENI''';
							
	EXECUTE IMMEDIATE 'INSERT INTO MARKET_PARTICIPANT (MARKET_PARTICIPANT_CODE,MARKET_PARTICIPANT_NAME,
                     CREATED_USER_ID,CREATED_DATE,MARKET_PARTICIPANT_ABBR_NAME)
                     VALUES (''ENI2'',''Enoi SPA'',''CCN10001654'',SYSDATE,''ENI'')';

	EXECUTE IMMEDIATE 'INSERT INTO ADDRESS (ADDRESS_ID,BUILDING_NUMBER,BUILDING_NAME,BUILDING_NAME_SUB,
                     ADDRESS_1,ADDRESS_2,ADDRESS_3,ADDRESS_4,POSTCODE_OUTCODE,POSTCODE_INCODE,
                     CREATED_USER_ID,CREATED_MARKET_PARTICIPANT,CREATED_DATE)
                     VALUES (ADDRESS_ID_SEQ.NEXTVAL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,''X9'',''9XX'',
                     ''CCN10001654'',''BSMART'',SYSDATE)';

	EXECUTE IMMEDIATE 'INSERT INTO MARKET_PARTICIPANT_IN_ROLE (MARKET_PARTICIPANT_CODE,MARKET_PARTICIPANT_ROLE_CODE,
                     EFFECTIVE_FROM_DATE,EFFECTIVE_TO_DATE,MARKET_PARTICIPANT_ROLE_NAME,ADDRESS_ID,
                     REGISTRATION_NUMBER,REGISTRATION_BODY,MARKET_PARTICIPANT_ROLE_ID,
                     MARKET_PARTICIPANT_ROLE_PORT,ORGANISATION_ID,CREATED_USER_ID,CREATED_DATE)
                     VALUES (''ENI2'',''SHIP'',TO_DATE(''01012000000000'',''DDMMYYYYHH24MISS''),NULL,
                     ''Enoi SPA (SHIP)'',ADDRESS_ID_SEQ.CURRVAL,NULL,NULL,''ENI'',''1'','''',
                     ''CCN10001654'',SYSDATE)';
					 
	EXECUTE IMMEDIATE 'DELETE FROM MARKET_PARTICIPANT_IN_ROLE
						WHERE MARKET_PARTICIPANT_CODE = ''ENI''
						AND MARKET_PARTICIPANT_ROLE_CODE = ''SHIP''';
						
	EXECUTE IMMEDIATE 'UPDATE MARKET_PARTICIPANT_IN_ROLE
                        SET MARKET_PARTICIPANT_ROLE_ID = ''ELK'',
                            LAST_UPDATE_USER_ID = ''CCN10001654'',
                            LAST_UPDATE_DATE = SYSDATE
                      WHERE MARKET_PARTICIPANT_CODE = ''ENI''
                        AND MARKET_PARTICIPANT_ROLE_CODE = ''MAP''';
						
EXCEPTION
  WHEN is_snapshot OR invalid_column THEN
    NULL;
END;
/
--
SET SCAN ON
--
COMMIT
/
--
SET VERIFY ON
--
